//SE RECOMIENDA USAR ESTA PLANTILLA CON LA VERSION MPLAB IDE V.8.63 Y COMPILADOR C18 V3.40
//ESTE PROGRAMA USA EL COMPILADOR C18. EL ARCHIVO (.HEX) RESULTANTE DE LA COMPILACION 
//DEBE CARGARSE EN LA TARJETA BOLT DESDE LA PC CON EL SOFTWARE BOOTLOADER "bolt 1.0.1"
//ES INDISPENSABLE INTEGRAR EN EL PROYECTO DE MPLAB EL ARCHIVO "rm18f2550.lkr" QUE ES UN 
//SCRIPT PARA EL LINKER DEL C18.TAMBIN SE RECOMIENDA INCLUIR EN EL PROYECTO
//LA LIBRERA UNIVERSAL "18F2550BOLT". LAS LIBRERIAS ADICIONALES Y ARCHIVOS COMPLETOS QUE 
//USTED PUEDE NECESITAR PARA SU PROYECTO LOS ENCONTRARA EN EL ARCHIVO 
//"C18-PLANTILLAS-LIBRERIAS-BOLT.ZIP"
//PROGRAMA PARA MODULO DE EXPANSION DE 7 SEGMENTOS.
//MUESTRA 3 DIGITOS. TECNICA DE MULTIPLEXAJE.


#include <p18cxxx.h>
#include <delays.h>
#include <stdio.h>		//librera sprintf()
#include <stdlib.h>		//libreras atoi(),atof()
#include "18F2550BOLT.h"

extern void _startup( void ); // See c018i.c in your C18 compiler dir 
#pragma code _RESET_INTERRUPT_VECTOR = 0x000800 
void _reset( void ) 
{ 
    _asm goto _startup _endasm 
} 

#pragma code

/*el siguiente arreglo contiene el patrn de segmentos encendidos en cada nmero del 0..9*/ 
char wip[]={0X7E,0X0C,0XB6,0X9E,0XCC,0XDA,0XFA,0X0E,0XFE,0XCE};						
char yep[]="803";
int rib;	
void seven(char *i);
void main(void)
{

init_bolt();
	while(1)
	{
		RA1=1;				//MASTER RESET A CONTADOR
		RA1=0;			
		for(rib=0;rib<3;rib++)	
		{
		seven(yep);
		}	
	}			
}

//FUNCION ESCRIBE EL NUMERO INDICADO EN MODULO
void seven(char *i)
{int j;	
RA2=1;						//CUENTA SIGUIENTE DISPLAY				
RA2=0;
j=*(i+rib)-48;						//CONVIERTE A BINARIO
PORTB=wip[j];				//ESCRIBE PATRON DE SEGMENTOS EN DISPLAY
delay_ms(5);				//RETRASO
}	
/*para explicar la tcnica de multiplexaje, pruebe con el
delay_ms(200) y luego con delay_ms(20) y finalmente delay_ms(5)*/








